<?xml version='1.0' encoding='UTF-8' ?>
<!--
  ~ Copyright (c) 2016 Roman Nazarenko.
  ~
  ~  This program is free software: you can redistribute it and/or modify
  ~  it under the terms of the GNU Affero General Public License as
  ~  published by the Free Software Foundation, either version 3 of
  ~  the License, or (at your option) any later version.
  ~
  ~  This program is distributed in the hope that it will be useful,
  ~  but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~  GNU General Public License for more details.
  ~
  ~  You should have received a copy of the GNU General Public License
  ~  along with this program.  If not, see <http://www.gnu.org/licenses/>.
  -->

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
		"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	  xmlns:h="http://xmlns.jcp.org/jsf/html"
	  xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
	  xmlns:f="http://xmlns.jcp.org/jsf/core"
	  xmlns:c="http://java.sun.com/jsp/jstl/core"
	  xmlns:o="http://omnifaces.org/ui"
	  xmlns:of="http://omnifaces.org/functions">

<h:head>
	<ui:include src="/WEB-INF/jsf/include/title.xhtml"/>
	<ui:include src="/WEB-INF/jsf/include/imports.xhtml"/>
	<ui:include src="/WEB-INF/jsf/include/init.xhtml"/>
</h:head>
<h:outputScript>
	changed = false
	$(function () {
		jsf.ajax.addOnEvent(function (event) {
			console.log('event status is ' + event.status);
			if (event.status === 'success') {
				registerMarkdownEditor();
				if ($(event.source).attr('id') === 'editProjectFormId:saveButton' &amp;&amp; isValidationSuccess()) {
					changeReset();
				}
				if ($(event.source).attr('id') === 'addProjectFormId:projectCreateButtonId' &amp;&amp; isValidationSuccess()) {
					$('#addProjectModalId').modal('hide');
				}
				if ($(event.source).attr('id') === 'editLinkFormId:editLinkSaveButtonId' &amp;&amp; isValidationSuccess()) {
					$('#editLinkModalId').modal('hide');
				}
				if ($(event.source).attr('id') === 'addLinkFormId:addLinkSaveButtonId' &amp;&amp; isValidationSuccess()) {
					$('#addLinkModalId').modal('hide');
				}
			}
		});
		registerMarkdownEditor();
	});

	function registerMarkdownEditor() {
		$('#editProjectFormId\\:markdownTextArea').markdown({
			resize: 'vertical',
			height: 1200,
		});
	}

	function isValidationSuccess() {
		return $('#validationStatus').text().trim() === 'true';
	}

	function unsavedChanges(msg) {
		return !changed || confirm(msg);
	}

	function unsavedChangesClean(msg) {
		if (unsavedChanges(msg)) {
			changeReset();
			return true;
		} else {
			return false;
		}
	}

	function onChange() {
		changed = true;
	}

	function changeReset() {
		changed = false;
	}
</h:outputScript>
<h:body styleClass="pushable">
	<div class="pusher">
		<div class="ui container framed">
			<ui:include src="/WEB-INF/jsf/include/header.xhtml"/>
			<h:panelGroup id="validationStatus" styleClass="hidden">
				${not facesContext.validationFailed}
			</h:panelGroup>
			<h:form id="projectsMenuId" styleClass="ui tabular menu">
				<ui:repeat value="${projectsHolderBean.projectsAll}" var="project">
					<h:link styleClass="${projectEditBean.isCurrent(project.internalName) ? 'active' : ''} item"
							value="${project.name}"
							outcome="/admin/projects.xhtml">
						<f:param name="${projectEditBean.nameParamter}" value="${project.internalName}"/>
					</h:link>
				</ui:repeat>
				<div class="item">
					<a onclick="if (unsavedChanges('Project creation discards changes made to the current project. Are you sure?')) $('#addProjectModalId').modal('show');">
						<i class="plus icon"></i>
					</a>
				</div>
				<div class="ui right tabular menu">
					<h:commandLink styleClass="item" action="#{projectEditBean.moveLeft}"
								   onclick="return unsavedChangesClean('Project moving discards all unsaved data, are you sure?');">
						<i class="ui left arrow icon"></i>
						<f:ajax render=":projectsMenuId :editProjectGroupId"/>
					</h:commandLink>
					<h:form>
						<h:commandLink styleClass="item" action="#{projectEditBean.moveRight}"
									   onclick="return unsavedChangesClean('Project moving discards all unsaved data, are you sure?');">
							<i class="ui right arrow icon"></i>
							<f:ajax render=":projectsMenuId :editProjectGroupId"/>
						</h:commandLink>
					</h:form>
				</div>
			</h:form>
			<div class="ui centered two columns footer-margin grid">
				<h:panelGroup id="editProjectGroupId" styleClass="ui thirteen wide column" layout="block">
					<h:panelGroup styleClass="ui raised segment"
								  rendered="${not projectEditBean.loaded}"
								  layout="block">
						<h2>No projects available</h2>
					</h:panelGroup>
					<h:panelGroup styleClass="ui raised segment"
								  rendered="${projectEditBean.loaded}"
								  layout="block">
						<h2>Edit project</h2>
						<h:form id="editProjectFormId"
								styleClass="ui ${facesContext.validationFailed ? 'error' : ''} form"
								enctype="multipart/form-data">
							<div class="ui divider"></div>
							<div class="ui centered two rows fluid stackable grid">
								<div class="ui two columns row">
									<div class="ui eleven wide column">
										<div class="field">
											<label>Project name</label>
											<h:inputText value="#{projectEditBean.get().name}"
														 onchange="onChange();"
														 validatorMessage="Project title is required">
												<f:passThroughAttribute name="placeholder" value="Name"/>
												<f:validateRequired/>
											</h:inputText>
										</div>
										<div class="field">
											<label>Project internal name</label>
											<h:inputText value="#{projectEditBean.get().internalName}"
														 onchange="onChange();"
														 validatorMessage="An internal name can only contain lowercase letters, digits and dashes">
												<f:passThroughAttribute name="placeholder"
																		value="(letters, digits, dashes)"/>
												<f:validateRegex pattern="[a-z\d\-]+"/>
												<f:validateRequired/>
											</h:inputText>
										</div>
										<div class="field">
											<div class="ui toggle checkbox">
												<h:selectBooleanCheckbox value="#{projectEditBean.get().published}"
																		 onchange="onChange();"/>
												<label>This project is published</label>
											</div>
										</div>
										<div class="field">
											<div class="ui right floated icon button"
												 onclick="$('#addLinkModalId').modal('show')">
												<i class="plus icon"></i>
											</div>
											<label>Project links</label>
											Edit and rearrange links shown at the left panel
											<h:panelGroup id="linksListId"
														  styleClass="ui ordered middle aligned celled list"
														  layout="block">
												<c:set var="pLinks" value="${projectEditBean.get().links}"/>
												<h:panelGroup layout="block" rendered="${not empty pLinks}">
													<ui:repeat value="${of:createIntegerArray(0, pLinks.size() - 1)}"
															   var="i">
														<div class="item">
															<div class="right floated content">
																<h:commandLink
																		action="#{projectEditBean.markLinkForEdit(i)}"
																		onclick="$('#editLinkModalId').modal('show');">
																	<i class="edit icon"></i>
																	<f:ajax render=":editLinkFormId"/>
																</h:commandLink>
																<h:commandLink
																		action="#{projectEditBean.moveLinkUp(i)}"
																		onclick="onChange();"
																		disabled="${i == 0}">
																	<i class="${i == 0 ? 'lock' : 'angle up'} icon"></i>
																	<f:ajax render=":editProjectFormId:linksListId"/>
																</h:commandLink>
																<h:commandLink
																		action="#{projectEditBean.moveLinkDown(i)}"
																		onclick="onChange();"
																		disabled="${i == pLinks.size() - 1}">
																	<i class="${i == pLinks.size() - 1 ? 'lock' : 'angle down'} icon"></i>
																	<f:ajax render=":editProjectFormId:linksListId"/>
																</h:commandLink>
																<h:commandLink
																		action="#{projectEditBean.removeLink(i)}"
																		onclick="onChange();">
																	<i class="red remove icon"></i>
																	<f:ajax render=":editProjectFormId:linksListId"/>
																</h:commandLink>
															</div>
															<div class="content">
																<c:set var="pLink" value="${pLinks.get(i)}"/>
																<div class="header">${pLink.name}</div>
																<div class="description">
																	<h:outputLink value="${pLink.url}">
																		${pLink.url}
																	</h:outputLink>
																</div>
															</div>
														</div>
													</ui:repeat>
												</h:panelGroup>
											</h:panelGroup>
										</div>
										<div class="ui error message">
											<h:messages showDetail="true" showSummary="false"/>
										</div>
									</div>
									<div class="ui five wide column">
										<div class="field">
											<label>Logo</label>
											<div class="image">
												<o:graphicImage value="${images.logo(projectEditBean.get().id)}"
																lastModified="${images.logoLastModified(projectEditBean.get().id)}"
																alt="No logo yet :("/>
											</div>
											<h:inputFile value="#{projectEditBean.logo.part}"
														 maxlength="${projectEditBean.maxLogoSize}"
														 onclick="onChange();">
												<f:passThroughAttribute name="placeholder" value="Logo"/>
											</h:inputFile>
										</div>
										<h:commandButton id="saveButton"
														 styleClass="ui primary button"
														 value="Save"
														 action="#{projectEditBean.save}">
											<f:ajax execute="@form"
													render=":editProjectGroupId :projectsMenuId :validationStatus"/>
										</h:commandButton>
										<h:commandButton styleClass="ui secondary button"
														 value="Clear"
														 action="#{projectEditBean.reset}"
														 onclick="unsavedChangesClean('Are you sure?');">
											<f:ajax execute="@form" render=":editProjectGroupId :projectsMenuId"/>
										</h:commandButton>
										<h:commandButton styleClass="ui red button"
														 value="Delete"
														 action="#{projectEditBean.delete}"
														 onclick="return confirm('Are you sure you want to delete this project?');">
											<f:ajax execute="@form" render=":editProjectGroupId :projectsMenuId"/>
										</h:commandButton>
									</div>
								</div>
								<div class="ui one columns row">
									<div class="ui sixteen wide column">
										<div class="field">
											<h:inputTextarea id="markdownTextArea"
															 value="#{projectEditBean.get().description}"
															 hideLabel="true"
															 onchange="onChange();">
											</h:inputTextarea>
										</div>
									</div>
								</div>
							</div>
						</h:form>
					</h:panelGroup>
				</h:panelGroup>
			</div>
		</div>
		<ui:include src="/WEB-INF/jsf/include/footer.xhtml"/>
	</div>
	<div id="addLinkModalId" class="ui small modal x">
		<div class="header">Add link</div>
		<div class="content">
			<h:form id="addLinkFormId"
					styleClass="ui ${errorUtils.formClass(component)} form">
				<div class="field">
					<label>Site title</label>
					<h:inputText value="#{newLinkTitle}"
								 validatorMessage="Site title is required">
						<f:passThroughAttribute name="placeholder" value="Title"/>
						<f:validateRequired/>
					</h:inputText>
				</div>
				<div class="field">
					<label>Site URL</label>
					<h:inputText value="#{newLinkUrl}">
						<f:passThroughAttribute name="placeholder" value="URL"/>
					</h:inputText>
				</div>
				<div class="ui error message">
					<h:messages showDetail="true" showSummary="false"/>
				</div>
				<h:commandButton id="addLinkSaveButtonId"
								 styleClass="ui positive button"
								 value="Save"
								 action="#{projectEditBean.addLink(newLinkTitle, newLinkUrl)}"
								 onclick="onChange(); $('#addLinkModalId').modal('hide')">
					<f:ajax execute="@form" render=":editProjectFormId:linksListId"/>
				</h:commandButton>
				<div class="ui deny button" onclick="$('#addLinkModalId').modal('hide')">Cancel</div>
			</h:form>
		</div>
	</div>
	<div id="editLinkModalId" class="ui small modal">
		<div class="header">Edit link</div>
		<div class="content">
			<h:form id="editLinkFormId"
					styleClass="ui ${errorUtils.formClass(component)} form">
				<div class="field">
					<label>Site title</label>
					<h:inputText value="#{projectEditBean.editingLinkName}"
								 validatorMessage="Site title is required">
						<f:passThroughAttribute name="placeholder" value="Title"/>
						<f:validateRequired/>
					</h:inputText>
				</div>
				<div class="field">
					<label>Site URL</label>
					<h:inputText value="#{projectEditBean.editingLinkUrl}">
						<f:passThroughAttribute name="placeholder" value="URL"/>
					</h:inputText>
				</div>
				<div class="ui error message">
					<h:messages showDetail="true" showSummary="false"/>
				</div>
				<h:commandButton id="editLinkSaveButtonId"
								 styleClass="ui positive button"
								 value="Save"
								 action="#{projectEditBean.doneLinkEditing}">
					<f:ajax execute="@form"
							render=":editProjectFormId:linksListId :editLinkFormId :validationStatus"/>
				</h:commandButton>
				<div class="ui deny button" onclick="$('#editLinkModalId').modal('hide')">Cancel</div>
			</h:form>
		</div>
	</div>
	<div id="addProjectModalId" class="ui small modal">
		<div class="header">Add project</div>
		<div class="content">
			<h:form id="addProjectFormId"
					styleClass="ui ${errorUtils.formClass(component)} form">
				<div class="field">
					<label>Project title</label>
					<h:inputText value="#{projectCreateBean.name}"
								 validatorMessage="Project name is required">
						<f:passThroughAttribute name="placeholder" value="Title"/>
						<f:validateRequired/>
					</h:inputText>
				</div>
				<div class="field">
					<label>Project alias</label>
					<h:inputText value="#{projectCreateBean.internalName}"
								 validatorMessage="An internal name can only contain lowercase letters, digits and dashes">
						<f:passThroughAttribute name="placeholder" value="(letters, digits, dashes)"/>
						<f:validateRegex pattern="[a-z\d\-]+"/>
						<f:validateRequired/>
					</h:inputText>
				</div>
				<div class="ui error message">
					<h:messages showDetail="true" showSummary="false"/>
				</div>
				<h:commandButton id="projectCreateButtonId"
								 styleClass="ui positive button"
								 value="Create"
								 action="#{projectCreateBean.create}">
					<f:ajax execute="@form"
							render=":editProjectGroupId :projectsMenuId :addProjectFormId :validationStatus"/>
				</h:commandButton>
				<div class="ui deny button" onclick="$('#addProjectModalId').modal('hide')">Cancel</div>
			</h:form>
		</div>
	</div>
</h:body>
</html>

